#include "../../src/Library/Items/Item.hpp"
#include <Arbutils/ConstString.hpp>
#include "../Core.hpp"
using namespace PkmnLib::Library;

export Item* PkmnLib_Item_Construct(const char* name, CreatureLib::Library::ItemCategory category,
                                    CreatureLib::Library::BattleItemCategory battleCategory, int32_t price,
                                    const char* flags[], size_t flagsCount, uint8_t flingPower) {
    std::unordered_set<uint32_t> conversedFlags(flagsCount);
    for (size_t i = 0; i < flagsCount; i++) {
        conversedFlags.insert(Arbutils::CaseInsensitiveConstString::GetHash(flags[i]));
    }

    return new Item(Arbutils::CaseInsensitiveConstString(name), category, battleCategory, price, conversedFlags,
                    flingPower);
};

export void PkmnLib_Item_Destruct(const Item* p) { delete p; }

#define SIMPLE_GET_FUNC(type, name, returnType)                                                                        \
    export returnType PkmnLib_##type##_##name(const PkmnLib::Library::type* p) { return p->name(); }

SIMPLE_GET_FUNC(Item, GetFlingPower, uint8_t)

#undef SIMPLE_GET_FUNC
