#ifndef PKMNLIB_WEATHERCHANGEEVENT_HPP
#define PKMNLIB_WEATHERCHANGEEVENT_HPP
#include <Arbutils/ConstString.hpp>
#include <CreatureLib/Battling/EventHooks/EventData.hpp>
#include "PkmnEventKind.hpp"

namespace PkmnLib::Battling {
    class WeatherChangeEvent : public CreatureLib::Battling::EventData {
        Arbutils::CaseInsensitiveConstString _weatherName;

    public:
        explicit WeatherChangeEvent(const Arbutils::CaseInsensitiveConstString& name) : _weatherName(name) {}

        [[nodiscard]] CreatureLib::Battling::EventDataKind GetKind() const noexcept override {
            return static_cast<CreatureLib::Battling::EventDataKind>(PkmnEventDataKind::WeatherChange);
        }
    };
}

#endif // PKMNLIB_WEATHERCHANGEEVENT_HPP
