#include "RegisterStaticLibraryTypes.hpp"
#include <cassert>
#include "../../../../Library/PokemonLibrary.hpp"

void RegisterStaticLibraryTypes::Register(asIScriptEngine* engine) {
    RegisterLibrarySettingsType(engine);
    RegisterLibraryType(engine);
}

void RegisterStaticLibraryTypes::RegisterLibrarySettingsType(asIScriptEngine* engine) {
    [[maybe_unused]] int r = engine->RegisterObjectType("LibrarySettings", 0, asOBJ_REF | asOBJ_NOCOUNT);
    r = engine->RegisterObjectMethod("LibrarySettings", "uint8 get_MaximalLevel() const property",
                                     asMETHOD(PkmnLib::Library::LibrarySettings, GetMaximalLevel), asCALL_THISCALL);
    assert(r >= 0);
    r = engine->RegisterObjectMethod("LibrarySettings", "uint8 get_MaximalMoves() const property",
                                     asMETHOD(PkmnLib::Library::LibrarySettings, GetMaximalMoves), asCALL_THISCALL);
    assert(r >= 0);
    r = engine->RegisterObjectMethod("LibrarySettings", "uint16 get_ShinyRate() const property",
                                     asMETHOD(PkmnLib::Library::LibrarySettings, GetShinyRate), asCALL_THISCALL);
    assert(r >= 0);
}

void RegisterStaticLibraryTypes::RegisterLibraryType(asIScriptEngine* engine) {
    [[maybe_unused]] int r = engine->RegisterObjectType("StaticLibrary", 0, asOBJ_REF | asOBJ_NOCOUNT);
    assert(r >= 0);
    r = engine->RegisterObjectMethod("StaticLibrary", "const LibrarySettings@ get_Settings() const property",
                                     asMETHOD(PkmnLib::Library::PokemonLibrary, GetSettings), asCALL_THISCALL);
    assert(r >= 0);
    r = engine->RegisterObjectMethod("StaticLibrary", "const SpeciesLibrary@ get_SpeciesLibrary() const property",
                                     asMETHOD(PkmnLib::Library::PokemonLibrary, GetSpeciesLibrary), asCALL_THISCALL);
    assert(r >= 0);
    r = engine->RegisterObjectMethod("StaticLibrary", "const MoveLibrary@ get_MoveLibrary() const property",
                                     asMETHOD(PkmnLib::Library::PokemonLibrary, GetMoveLibrary), asCALL_THISCALL);
    assert(r >= 0);
    r = engine->RegisterObjectMethod("StaticLibrary", "const ItemLibrary@ get_ItemLibrary() const property",
                                     asMETHOD(PkmnLib::Library::PokemonLibrary, GetItemLibrary), asCALL_THISCALL);
    assert(r >= 0);
    r = engine->RegisterObjectMethod("StaticLibrary", "const GrowthRateLibrary@ get_GrowthRateLibrary() const property",
                                     asMETHOD(PkmnLib::Library::PokemonLibrary, GetGrowthRates), asCALL_THISCALL);
    assert(r >= 0);
    r = engine->RegisterObjectMethod("StaticLibrary", "const TypeLibrary@ get_TypeLibrary() const property",
                                     asMETHOD(PkmnLib::Library::PokemonLibrary, GetTypeLibrary), asCALL_THISCALL);
    assert(r >= 0);


}
