#ifdef TESTS_BUILD
#include "../../extern/catch.hpp"
#include "../../src/Battling/Pokemon/CreatePokemon.hpp"
#include "../TestLibrary/TestLibrary.hpp"

TEST_CASE("Create and delete Pokemon"){
    auto lib = TestLibrary::GetLibrary();
    auto mon = PkmnLib::Battling::CreatePokemon(lib, "testSpecies"_cnc, 1).Build();
    delete mon;
}

TEST_CASE("Get Nature from Pokemon"){
    auto lib = TestLibrary::GetLibrary();
    auto mon = PkmnLib::Battling::CreatePokemon(lib, "testSpecies"_cnc, 1)
        .WithNature("neutralNature"_cnc)
        ->Build();
    auto nature = mon->GetNature();
    REQUIRE(nature->GetDecreaseModifier() == 1);
    REQUIRE(nature->GetIncreaseModifier() == 1);
    delete mon;
}


#endif